/*
 * Créé le 27 juin 07
 *
 * Pour changer le modèle de ce fichier généré, allez à :
 * Fenêtre&gt;Préférences&gt;Java&gt;Génération de code&gt;Code et commentaires
 */

package fr.gouv.finances.cp.xemelios.export;

import java.util.Vector;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.InvalidXmlDefinition;
import fr.gouv.finances.cp.utils.xml.marshal.XmlAttributes;
import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshallable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;
import javax.xml.namespace.QName;

public class ExportModel implements XmlMarshallable {
	
	public static final transient String TAG = "export";
        public static final transient QName QN = new QName(TAG);
	
	private Vector<ExportElementModel> enfants;
	private String id, libelle, code;
	
	public ExportModel (QName tagName) {
		id = libelle = code = "";
		enfants = new Vector<ExportElementModel>();
	}

	public void addCharacterData(String cData) throws SAXException {}

	public void addChild(XmlMarshallable child, QName tagName) throws SAXException {
		enfants.add((ExportElementModel)child);
	}

	public XmlMarshallable getAttributes(XmlAttributes attributes) throws SAXException {
		id = attributes.getValue("id");
		libelle = attributes.getValue("libelle");
		code = attributes.getValue("code");
		return this;
	}

	public void marshall(XmlOutputter output) {
		output.startTag("export");
		output.addAttribute("id", id);
		output.addAttribute("libelle", libelle);
		output.addAttribute("code", code);
		for (ExportElementModel em:enfants) { em.marshall(output); }
		output.endTag("export");
	}
	
	public ExportModel clone () {
		ExportModel em = new ExportModel(QN);
		em.setId(id);
		em.setLibelle(libelle);
		em.setCode(code);
		for (ExportElementModel e:enfants) {
			try { em.addChild(e, ExportElementModel.QN); } catch (Exception ex) {}
		}
		return em;
	}

	public void validate() throws InvalidXmlDefinition {}

	public Vector<ExportElementModel> getEnfants() {
		return enfants;
	}

	public void setEnfants(Vector<ExportElementModel> enfants) {
		this.enfants = enfants;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getLibelle() {
		return libelle;
	}

	public void setLibelle(String libelle) {
		this.libelle = libelle;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public void addEnfant (ExportElementModel enf) {
		enfants.add(enf);
	}

    public XmlMarshallable getChildToModify(String uri, String localName, String qName, Attributes atts) {
        return null;
    }

    public QName getQName() {
        return QN;
    }
}
